import React, { useState, useCallback, useEffect } from 'react';
import ReactDOM from 'react-dom';
import { scaleSqrt, max } from 'd3';
import { useWorldAtlas } from './useWorldAtlas';
import { useCountries } from './useCountries';
import { Marks } from './Marks';
import { Dropdown } from './Dropdown';
import { attributes } from './DropdownAttr';

const width = 960;
const height = 500;

const App = () => {
  const initialYear = 'Last available-Number';
  var [year, setYear] = useState(initialYear);
  
        if (year == 'Last available-Number') {
        year = 'Last available-Number';
      } else {
       year = +year; 
      };


  const worldAtlas = useWorldAtlas();
  const countries = useCountries();
  

  if (!worldAtlas || !countries) {
    return <pre>Loading...</pre>;
  }

  const sizeValue = d => d[year];
  const maxRadius = 30;

  const sizeScale = scaleSqrt()
    .domain([0, max(countries, sizeValue)])
    .range([0, maxRadius]);
  

  return (
    <>
      <div className="menus-container">
        <span className="dropdown-label">Year:</span>
        <Dropdown
          options={attributes}
          id="x-select"
          value={year}
          onSelectedValueChange={setYear}
          // onChange={({ value }) => setXAttribute(value)}
        />
      </div>

      <svg width={width} height={height}>
        <Marks
          worldAtlas={worldAtlas}
          countries={countries}
          sizeScale={sizeScale}
          sizeValue={sizeValue}
        />
      </svg>
    </>
  );
};
const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);
